<cfimport prefix="l" taglib="layout" />

<cfoutput>
<l:header title="No-Refresh Save" onload="setInterval('save();', 10000);">
	<script type="text/javascript">
	// <![CDATA[
		function save() {
			setStatus("Autosaving....", "inProgress");
			new Ajax.Request($("cssForm").action,
				{
					postBody: {
						css: $F("css")
					},
					onSuccess: function(t) {
						setStatus("Success", "success");
					},
					onError: function(t) {
						setStatus("Error", "error");
					},
					onFailure: function(t) {
						setStatus("Error", "error");
					}
				}
			);
		}
		function setStatus(message, className) {
			var s = $("status");
			s.innerHTML = message;
			s.className = className;
			if (message != "") {
				setTimeout("setStatus('&nbsp;', '');", 5000);
			}
		}
	// ]]>
	</script>
	<style type="text/css">
		/* <![CDATA[ */
		.inProgress {
			color: ##f90;
			background-color: ##fff7ee;
		}
		.error {
			color: ##f00;
			background-color: ##fee;
		}
		.success {
			color: ##090;
			background-color: ##eef7ee;
		}
		/* ]]> */
	</style>
</l:header>
<p><strong>Problem:</strong> Users can lose their work if their browsers crash, or the
time out during long editing sessions.
</p>
<p><strong>Example:</strong> Users create documents on the site, and they occasionally
time out, or have to abort mid-editing.
</p>
<p><strong>Solution:</strong> Add a periodic background save that rips content out of
the form and submits it to the server.
</p>
<p><strong>Caveats:</strong> Some rich text editors have issues with having content ripped
out in the background.
</p>
<p><a href="save_no_refresh_test.cfm" target="_blank">launch test page</a>
</p>
<form id="cssForm" method="post" action="save_no_refresh_action.cfm">
<div class="clearAll"></div>
<div class="formItem">
	<label for="name">CSS:</label>
	<div class="indicator" id="indicator_name">*</div>
	<div class="formField">
		<textarea name="css" id="css" style="width:400px;height:150px;"><cfinclude template="#SAVED_CSS#" /></textarea>
		<span class="message" id="message_name"></span>
	</div>
</div>
<div class="formItem">
	<label></label>
	<div class="indicator"></div>
	<div id="status" class="formField">&nbsp;</div>
</div>
<div class="formItem">
	<label></label>
	<div class="indicator="></div>
	<div class="formField">
		<input type="submit" value="Submit" />
		<input type="button" value="Save" onclick="save();" />
	</div>
</div>
</form>
<l:footer />
</cfoutput>