<cfimport prefix="l" taglib="layout" />

<cfoutput>
<l:header title="Closures" includeNeuromancer="false" includeScriptaculous="false">
	<script type="text/javascript">
	// <![CDATA[
		function call(f) {
			f();
		}
		
		function simple() {
			var s = "hello, world!";
			call(function() {
				alert(s);
			});
		}
		
		function onTimeout() {
			var s = "Check it foo!  I'm still here!";
			setTimeout(function() {
				alert(s);
			}, 1000);
		}
		
		function onTimeout2() {
			var f = function() {
				alert(s);
			};
			var s = "This worked too.";
			setTimeout(f, 1000);
		}
		
		function onTimeout3() {
			var s = "Yesssssss!  This worked as well."
			setTimeout("alert(s);", 1000);
		}
	// ]]>
	</script>
</l:header>

<p>Closures refer to a function having access to the scope it's defined in
when it is eventually invoked, regardless of whether that scope still
exists or not.  Java inner classes have this characteristic as well.
</p>

<form>
<input type="button" value="simple" onclick="simple();" />
<input type="button" value="onTimeout" onclick="onTimeout();" />
<input type="button" value="onTimeout2" onclick="onTimeout2();" />
<input type="button" value="onTimeout3" onclick="onTimeout3();" />
</form>

<l:footer />
</cfoutput>