<cfcomponent>

	<cffunction name="greet" access="remote" returntype="string"
			hint="I greet the named individual">
		<cfargument name="name" type="string" required="true" />
		<cfreturn "Hello, #arguments.name#!" />
	</cffunction>
	
	
	
	<cffunction name="getUserInfo" access="remote" returntype="struct"
			hint="I return user info for the user represented by the supplied id">
		<cfargument name="id" type="numeric" required="true" />
		<!---
		Dummy implementation that returns hard-coded info
		--->
		<cfset var result = structNew() />
		
		<cfset result["userid"] = arguments.id />
		<cfset result["name"]["first"] = "Barney" />
		<cfset result["name"]["last"] = "Boisvert" />
		<cfset result["username"] = "barneyb" />
		<cfset result["dateofbirth"] = createDateTime(1980, 6, 10, 0, 8, 0) />
		
		<cfreturn result />
	</cffunction>
	
	
	
	<cffunction name="isUsernameValid" access="remote" returntype="boolean">
		<cfargument name="username" type="string" required="true" />
		<cfif len(username) LT 4>
			<cfreturn false />
		<cfelseif len(username) GT 16>
			<cfreturn false />
		<cfelse>
			<!--- sufficient length, check uniqueness --->
			<cfreturn listFind("barneyb,hmboisvert", username) EQ 0 />
		</cfif>
	</cffunction>

</cfcomponent>
