<cfimport prefix="l" taglib="layout" />

<cfoutput>
<l:header title="Function Literals" includeNeuromancer="false" includeScriptaculous="false">
	<script type="text/javascript">
	// <![CDATA[
		function call(f) {
			f();
		}
		
		function inlineCall() {
			call(function() {
				alert("I'm the inline-defined function literal inside inlineCall");
			});
		}
		
		window.myFunction = function() {
			alert("myFunction called");
		}
		
		window.myOtherFunction = window.myFunction;
	// ]>
	</script>
</l:header>

<p>In JavaScript, functions are nothing more than variables.  They can be passed around
like variables, reassigned like variables, and then called like functions wherever they
reside.  CF has similar functionality with UDFs.
</p>

<p>Where JavaScript and CF diverge, however, is with literals.  There's no way to
create a function in CF except by declaring it.  With JavaScript you can create a
function without declaring it, which is a very powerful concept.
</p>

<form>
<input type="button" value="myFunction" onclick="window.myFunction();" />
<input type="button" value="myOtherFunction" onclick="window.myOtherFunction();" />
<input type="button" value="call" onclick="call(window.myFunction);" />
<input type="button" value="inlineCall" onclick="inlineCall();" />
</form>

<l:footer />
</cfoutput>