<cfimport prefix="l" taglib="layout/" />

<cfoutput>
<l:header title="JS Remoting" includeNeuromancer="false" includePrototype="false" includeScriptaculous="false" />
<p>Base Examples:
</p>
<ol>
	<li><a href="func_literal.cfm">function literals</a>
	</li>
	<li><a href="nested_functions.cfm">nested functions</a>
	</li>
	<li><a href="closures.cfm">closures</a>
	</li>
</ol>

<p>Two packages are used in my demos:
</p>
<ul>
	<li><a href="http://neuromancer.sourceforge.net/">Neuromancer</a> - A JS
		remoting and UI toolkit primarily built by Rob Rohan.  Along with Rob,
		I am a committer on the project.
	</li>
	<li><a href="http://script.aculo.us/">Script.aculo.us</a> - a JS remoting
		and UI toolkit based on <a href="http://prototype.conio.net/">Prototype</a>.
		Prototype is required, and is included in the distribution.  Both projects
		are housed by the Rails framework, though they aren't directly associated.
	</li>
</ul>
<p>Illustrative Examples:
</p>
<ol>
	<li><a href="neuro_get.cfm">simple GET (N)</a> - a simple HTTP GET with Neuromancer
	</li>
	<li><a href="neuro_post.cfm">simple POST (N)</a> - a simple HTTP POST with Neuromancer
	</li>
	<li><a href="neuro_remote.cfm">remoting (N)</a> - remoting of a web service object with Neuromancer
	</li>
	<li><a href="script_get.cfm">simple GET (S)</a> - a simple HTTP GET with Script.aculo.us
	</li>
	<li><a href="script_post.cfm">simple POST (S)</a> - a simple HTTP POST with Script.aculo.us
	</li>
</ol>
<p>Real-World Examples:
<ol>
	<li><a href="ss_validation.cfm">server-side validation (S)</a> - performing server-side validation
		without submitting the form.
	</li>
	<li><a href="ss_validation2.cfm">server-side validation 2 (N)</a> - The same thing, but with remoting.
	</li>
	<li><a href="save_no_refresh.cfm">no-refresh save</a> - user-requested background save of form contents.
	</li>
	<li><a href="autosave.cfm">autosave</a> - async autosave of form contents.
	</li>
	<!---
	<li><a href="batch_ops.cfm">batch operations</a> - avoiding a refresh, so sequencial ops are easier.
	</li>
	--->
</ol>
</p>
<l:footer />
</cfoutput>