<cfif thistag.executionMode EQ "start">
	<cfset NEUROMANCER_UTIL = "util/Log,util/Collections,util/BrowserSniffer" />
	<cfset NEUROMANCER_UI = "ui/Mouse,ui/EventManager" />
	<cfset NEUROMANCER_XML = "xml/XmlSax,xml/XmlW3CDom,xml/XmlDocument" />
	<cfset NEUROMANCER_HTTP = "io/Gateway" />
	<cfset NEUROMANCER_REMOTING = "#NEUROMANCER_XML#,io/RemoteObject" />
	<cfset PROTOTYPE = "base,string,enumerable,array,hash,range,ajax,dom,selector,form,event,position" />
	<cfset SCRIPTACULOUS = "scriptaculous" />
	
	<cfset NEUROMANCER_ROOT = "static/neuromancer/js/" />
	<cfset PROTOTYPE_ROOT = "static/prototype/src/" />
	<cfset SCRIPTACULOUS_ROOT = "static/scriptaculous/src/" />

	<cfparam name="attributes.title" type="string" default="No Title" />
	<cfparam name="attributes.includeNeuromancer" type="boolean" default="true" />
	<cfparam name="attributes.includeNeuromancerRemoting" type="boolean" default="false" />
	<cfparam name="attributes.includeScriptaculous" type="boolean" default="true" />
	<cfparam name="attributes.includePrototype" type="boolean" default="true" />
	<!--- gotta include prototype if we have script.aculo.us --->
	<cfset attributes.includePrototype = attributes.includePrototype OR attributes.includeScriptaculous />
	<cfparam name="attributes.onload" default="" />
<cfelse>
	<cfset headContent = thistag.generatedContent />
	<cfset thistag.generatedContent = "" />
	<cfoutput>
	<html>
	<head>
		<title>#attributes.title#</title>
		<link rel="stylesheet" href="static/style.css" type="text/css" />
		<cfif attributes.includeNeuromancer>
			<cfset files = "#NEUROMANCER_UTIL#,#NEUROMANCER_HTTP#" />
			<cfif attributes.includeNeuromancerRemoting>
				<cfset files = "#files#,#NEUROMANCER_REMOTING#" />
			</cfif>
			<!--- UI belongs after UTIL, if needed --->
			<cfloop list="#files#" index="base">
				<script type="text/javascript" src="#NEUROMANCER_ROOT##base#.js"></script></cfloop>
			<script type="text/javascript">
				// <![CDATA[
				FACADE_URL = "facade.cfc";
				function getGateway(async) {
					if (typeof async == "undefined")
						async = true;
					return new JSRemote(new HTTPConnectFactory().getInstance(), async);
				}
				// ]]>
			</script>
		</cfif>
		<cfif attributes.includePrototype>
			<!--- this is the 'prototype.js' file that can't be included directly, because
				it's got assembly instructions included inline
			--->
			<script type="text/javascript">
				// <![CDATA[
				var Prototype = {
				  Version: '1.5.0_rc0',
				  ScriptFragment: '(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)',
				  
				  emptyFunction: function() {},
				  K: function(x) {return x}
				}
				// ]]>
			</script>
			<cfloop list="#PROTOTYPE#" index="base">
				<script type="text/javascript" src="#PROTOTYPE_ROOT##base#.js"></script></cfloop>
		</cfif>
		<cfif attributes.includeScriptaculous>
			<cfloop list="#SCRIPTACULOUS#" index="base">
				<script type="text/javascript" src="#SCRIPTACULOUS_ROOT##base#.js"></script></cfloop>
		</cfif>
		#headContent#
	</head>
	<body<cfif len(attributes.onload) GT 0> onload="#attributes.onload#"</cfif>>
	<a href="index.cfm" id="homeLink">HOME</a>
	<div id="timeBar">
		It's currently #dateFormat(now(), "yyyy-mm-dd")# #timeFormat(now(), "HH:mm")#:<span style="font-weight:bold;color:##c00;font-size:1.1em;">#timeFormat(now(), "ss")#</span>
	</div>
	<h1>#attributes.title#</h1>
	</cfoutput>
</cfif>