<cfimport prefix="l" taglib="layout/" />

<cfoutput>
<l:header title="Neuromancer Remoting" onload="loadFacade();" includeNeuromancerRemoting="true">
	<script type="text/javascript">
		// <![CDATA[
		// fire up the Neuromancer logging/console facilities
		DEBUG = true;
		log.init();

		window.facade = null;
		function loadFacade() {
			new RemoteObjectLoader(FACADE_URL, function(ro) {
				window.facade = ro;
			}, true); // async mode
		}
		function isLoaded() {
			if (typeof window.facade == "undefined" || window.facade == null) {
				alert("The facade is not yet loaded - try again in a few seconds");
				return false;
			}
			return true;
		}
		
		function greet(name) {
			if (! isLoaded()) {
				return;
			}
			window.facade.greet(name, function(s) {
				$('greeting').innerHTML = s;
			});
		}
		function getUserInfo(id, dest_raw, dest) {
			if (! isLoaded()) {
				return;
			}
			window.facade.getUserInfo(id, new DefaultHandler(function(info) {
				$(dest_raw).innerHTML = info;
				var labelAttrs = {className:"label"};
				$(dest).appendChild(Builder.node("table", {border:1,cellspacing:0,cellpadding:3,className:"infoTable"}, [
					Builder.node("tbody", [
						Builder.node("tr", [
							Builder.node("td", labelAttrs, "Username:"),
							Builder.node("td", info.get("username"))
						]),
						Builder.node("tr", [
							Builder.node("td", labelAttrs, "First Name:"),
							Builder.node("td", info.get("name").get("first"))
						]),
						Builder.node("tr", [
							Builder.node("td", labelAttrs, "Last Name:"),
							Builder.node("td", info.get("name").get("last"))
						]),
						Builder.node("tr", [
							Builder.node("td", labelAttrs, "Date of Birth:"),
							Builder.node("td", dateFormat(info.get("dateofbirth")))
						])
					])
				]));
			}).handle);
		}
		function dateFormat(d) {
			return (d.getMonth() + 1) + "/" + d.getDate() + "/" + d.getFullYear();
		}
		// ]]>
	</script>
	<style type="text/css">
		/* <![CDATA[ */
		td.label {
			font-size: 0.9em;
			text-align: left;
			font-weight: bold;
			vertical-align: top;
			background-color: ##eee;
		}
		/* ]]> */
	</style>
</l:header>
<form>
	<input name="name" id="f_name" value="Barney" />
	<input type="button" value="Greet" onclick="greet($('f_name').value);" />
	<span id="greeting"></span><br />
	<input type="button" value="Get User Info" onclick="getUserInfo(42, 'userInfo_raw', 'userInfo');" />
	<div id="userInfo_raw"></div>
	<div id="userInfo"></div>
</form>
<l:footer />
</cfoutput>