<cfimport prefix="l" taglib="layout" />

<cfoutput>
<l:header title="No-Refresh Save">
	<script type="text/javascript">
	// <![CDATA[
		window.timeout = null;
		function save() {
			setStatus("Saving....", "inProgress");
			clearTimeout(timeout);
			timeout = setTimeout("setStatus('Error', 'error')", 5000);
			getGateway().doFormPostRequest($("cssForm").action,
				{
					css: $F("css")
				},
				function(s) {
					setStatus("Success", "success");
					clearTimeout(timeout);
				}
			);
		}
		function setStatus(message, className) {
			var s = $("status");
			s.innerHTML = message;
			s.className = className;
			if (message != "") {
				setTimeout("setStatus('&nbsp;', '');", 5000);
			}
		}
	// ]]>
	</script>
	<style type="text/css">
		/* <![CDATA[ */
		.inProgress {
			color: ##f90;
			background-color: ##fff7ee;
		}
		.error {
			color: ##f00;
			background-color: ##fee;
		}
		.success {
			color: ##090;
			background-color: ##eef7ee;
		}
		/* ]]> */
	</style>
</l:header>
<p><strong>Problem:</strong> You want users to be able to save, without having to refresh.
</p>
<p><strong>Example:</strong> Tweaking CSS on a site layout; don't want to refresh, because
you don't want to lose your in-browser 'undo stream' when you save.
</p>
<p><strong>Solution:</strong> Add a 'Save' button to your form that uses an JS Remoting
POST to submit the form in the background.
</p>
<p><strong>Caveats:</strong> Not really any.  You can even capture the CTRL-s keystroke
and do the save based on that for extra points.  ;)
</p>
<p><a href="save_no_refresh_test.cfm" target="_blank">launch test page</a>
</p>
<form id="cssForm" method="post" action="save_no_refresh_action.cfm">
<div class="clearAll"></div>
<div class="formItem">
	<label for="name">CSS:</label>
	<div class="indicator" id="indicator_name">*</div>
	<div class="formField">
		<textarea name="css" id="css" style="width:400px;height:150px;"><cfinclude template="#SAVED_CSS#" /></textarea>
		<span class="message" id="message_name"></span>
	</div>
</div>
<div class="formItem">
	<label></label>
	<div class="indicator"></div>
	<div id="status" class="formField">&nbsp;</div>
</div>
<div class="formItem">
	<label></label>
	<div class="indicator="></div>
	<div class="formField">
		<input type="submit" value="Submit" />
		<input type="button" value="Save" onclick="save();" />
	</div>
</div>
</form>
<l:footer />
</cfoutput>