<cfimport prefix="l" taglib="layout/" />

<cfoutput>
<l:header title="Server-Side Validation" onload="loadFacade();" includeNeuromancerRemoting="true">
	<script type="text/javascript">
		// <![CDATA[
		// fire up the Neuromancer logging/console facilities
		DEBUG = true;
		log.init();

		window.facade = null;
		function loadFacade() {
			new RemoteObjectLoader(FACADE_URL, function(ro) {
				window.facade = ro;
			}, true); // async mode
		}
		function isLoaded() {
			if (typeof window.facade == "undefined" || window.facade == null) {
				alert("The facade is not yet loaded - try again in a few seconds");
				return false;
			}
			return true;
		}
		
		function validateForm() {
			var formIsClean = true;
			formIsClean = validateName("name") && formIsClean;
			formIsClean = validateUsername("username", true) && formIsClean;
			formIsClean = validateEmail("email") && formIsClean;
			return formIsClean;
		}
		function validateName(el) {
			clearError(el);
			if ($F(el) == "") {
				setError(el, "You must provide your name");
				return false;
			}
			return true;
		}
		function validateUsername(el, localOnly) {
			if (typeof localOnly == undefined) {
				localOnly = false;
			}
			
			clearError(el);
			if ($F(el).length < 4) {
				setError(el, "Usernames must be at least 4 characters long");
				return false;
			}
			if ($F(el).length > 16) {
				setError(el, "Usernames cannot be more than 16 characters long");
				return false;
			}
			
			if (! localOnly) {
				facade.isUsernameValid($F(el), function(s) {
					if (isValid = s != "true") {
						setError(el, "The username you've chosen is not unique; please select another");
					}
				});
			}

			return true;
		}
		function validateEmail(el) {
			clearError(el);
			if (! /.+@.+/.test($F(el))) {
				setError(el, "You must provide a valid email address");
				return false;
			}
			return true;
		}
		function clearError(el) {
			setError(el, "");
		}
		function setError(el, message) {
			$("message_" + $(el).id).innerHTML = message;
		}
		// ]]>
	</script>
</l:header>
<form onsubmit="return validateForm();">
<div class="clearAll"></div>
<div class="formItem">
	<label for="name">Name:</label>
	<div class="indicator" id="indicator_name">*</div>
	<div class="formField">
		<input name="name" id="name" onchange="validateName(this);" />
		<span class="message" id="message_name"></span>
	</div>
</div>
<div class="formItem">
	<label for="username">Username:</label>
	<div class="indicator" id="indicator_username">*</div>
	<div class="formField">
		<input name="username" id="username" onchange="validateUsername(this);" />
		<span class="message" id="message_username"></span>
	</div>
</div>
<div class="formItem">
	<label for="email">Email:</label>
	<div class="indicator" id="indicator_email">*</div>
	<div class="formField">
		<input name="email" id="email" onchange="validateEmail(this.id);" />
		<span class="message" id="message_email"></span>
	</div>
</div>
<div class="formItem">
	<label></label>
	<div class="indicator"></div>
	<div class="formField">
		<input type="submit" value="Submit" />
	</div>
</div>
<div class="clearAll"></div>
</form>
<l:footer />
</cfoutput>